/* Integrating DJ Native Swing into NetBeans RCP
 *
 * See the DJ Project by Christopher Deckers
 * http://djproject.sourceforge.net/ns/index.html
 *
 * Geertjaan Wielenga "Step-by-Step Instructions for Integrating DJ Native
 * Swing into NetBeans RCP"
 * http://netbeans.dzone.com/how-to-nb-djnative-swing?utm_source=feedburner&utm_
 * medium=feed&utm_campaign=Feed%3A+zones%2Fnetbeans+%28NetBeans+Zone%29
 *
 * Eclipse swt library
 * http://download.eclipse.org/eclipse/downloads/drops/R-3.6-201006080911/
 *
 * This code may be freely distributed and modified under the
 * terms of the GNU Lesser General Public Licence v2.1.
 */

package org.starbeans.api.nativeswing.browser;

import java.awt.event.ActionEvent;
import java.net.URL;
import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import org.openide.awt.HtmlBrowser;
import org.openide.filesystems.FileObject;
import org.openide.util.ImageUtilities;

public class BookmarkAction extends AbstractAction {

    private String urlString;

    public BookmarkAction(FileObject config) {
        super((String) config.getAttribute("displayName"));
        String iconString = (String) config.getAttribute("iconBase");
        if (iconString == null || iconString.isEmpty()) {
            Icon icon = new ImageIcon(ImageUtilities.loadImage("org/starbeans/api/nativeswing/resources/webicon.png")); //NOI18N
            putValue(Action.SMALL_ICON, icon);
        } else {
            Icon icon = new ImageIcon(ImageUtilities.loadImage(iconString));
            putValue(Action.SMALL_ICON, icon);
            putValue("iconBase", iconString);
        }
        urlString = (String) config.getAttribute("url");
    }

    public static BookmarkAction createFactory(FileObject config) {
        return new BookmarkAction(config);
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        URL url = IUtil.getURLFromString(urlString);
        if (!BrowserWindow.ShowBrowserWindow(url) && url != null) {
            HtmlBrowser.URLDisplayer.getDefault().showURL(url);
        }
    }
}
