/*
 * @author George Waldon
 *
 * This code may be freely distributed and modified under the
 * terms of the GNU Lesser General Public Licence v2.1.
 */
package org.starbeans.api.nativeswing.browser;

import java.io.IOException;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.UnknownHostException;

/**
 *
 * @author George Waldon
 */
public class IUtil {

    /** Create an URL from a string and add the "http://" string if
     * necessary.
     */
    public static URL getURLFromString(String urlString) {
        try {
            return new URL(urlString);
        } catch (MalformedURLException mue1) {
        }

        try {
            return new URL("http://" + urlString); //NOI18N
        } catch (MalformedURLException mue1) {
        }
        return null;
    }

    /** Test whether an URL is reachable over the internet.
     * 
     */
    public static boolean isInternetReachable(URL url) {
        try {
            HttpURLConnection urlConnect = (HttpURLConnection) url.openConnection();
            // Retrieve data from the source. If there
            // is no connection, this line will fail
            Object objData = urlConnect.getContent();
        } catch (UnknownHostException e) {
            return false;
        } catch (IOException e) {
            return false;
        }
        return true;
    }
}
